"""
Fitter class for control fit of ration of  B -> D l nu  vs.  B -> D* l nu  decays.

Felix Metzner 2022
"""

import numpy as np
import pandas as pd

from typing import Optional

from rdstar.utilities.logging import log_to_default

from rdstar.offline_analysis.fitting.dedicated_fit_approach.fitter_base import FitterBase
from rdstar.offline_analysis.fitting.dedicated_fit_approach.fit_info_container import FitSetupInfoContainer


__all__ = [
    "DvsDStarFitter",
]


logger = log_to_default(name=__name__)


class DvsDStarFitter(FitterBase):
    def __init__(
        self,
        *ignore,
        fit_setup_info: FitSetupInfoContainer,
        mc_df: pd.DataFrame,
        data_df: Optional[pd.DataFrame],
        **kwargs,
    ) -> None:
        super().__init__(
            *ignore,
            mc_df=mc_df,
            data_df=data_df,
            fit_setup_info=fit_setup_info,
            **kwargs,
        )

    # region cost function
    def cost_fcn(self, params: np.ndarray) -> float:
        return self.chi2_fcn(params=params) + self.gaussian_constrains(params=params)

    def chi2_fcn(self, params: np.ndarray) -> float:
        pass

    def gaussian_constrains(self, params: np.ndarray) -> float:
        pass

    # endregion

    # region expected bin count
    def expected_bin_counts(self, params: np.ndarray) -> np.ndarray:
        pass

    # endregion
