"""
Utilities for generator level MC matching.

Felix Metzner 2023
"""


from typing import Dict

from rdstar.utilities.logging import log_to_default

from rdstar.offline_analysis.mc_matching.mc_matching_utilities import MatchQueryInfo


__all__ = [
    "GenQueryDictType",
    #
    "get_gen_b_id_col_name",
]


logger = log_to_default(name=__name__)


GenQueryDictType = Dict[str, MatchQueryInfo]


def get_gen_b_id_col_name(b_index: int) -> str:
    assert isinstance(b_index, int), (b_index, type(b_index).__name__)
    assert b_index in (1, 2), b_index
    return f"GEN_B{b_index}_ID"
